/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterTriangulationSeries } from "./ScatterTriangulationSeries";
import { DependencyProperty } from "igniteui-angular-core";
import { Point_$type, typeCast, Number_$type, fromEnum, runOn, delegateRemove, delegateCombine, markType, markDep } from "igniteui-angular-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { FastItemIntColumn } from "igniteui-angular-core";
import { LinearContourValueResolver } from "./LinearContourValueResolver";
import { SeriesView } from "./SeriesView";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { ContourBuilder } from "./ContourBuilder";
import { Clipper } from "igniteui-angular-core";
import { RectUtil } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { BrushUtil } from "igniteui-angular-core";
import { BrushCollection } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { boxArray$1 } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { PathFigure } from "igniteui-angular-core";
import { PointCollectionUtil } from "igniteui-angular-core";
import { PolyLineSegment } from "igniteui-angular-core";
import { Tuple$2 } from "igniteui-angular-core";
import { GeometryUtil } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ScatterContourSeries = /*@__PURE__*/ (() => {
    class ScatterContourSeries extends ScatterTriangulationSeries {
        constructor() {
            super();
            this.y6 = null;
            this.y1 = null;
            FastItemIntColumn.m();
            this.ab = ScatterContourSeries.$;
            this.y2 = new LinearContourValueResolver();
        }
        bk() {
            return new ScatterContourSeries();
        }
        get_fk() {
            return true;
        }
        ku(a, b) {
            let c = this.ni(b);
            if (c == ScatterContourSeries.$$p[4]) {
                return this.kv(a, b, this.zf);
            }
            return super.ku(a, b);
        }
        mi(a) {
            let b = this.ni(a);
            if (b == ScatterContourSeries.$$p[4]) {
                return this.zf;
            }
            return super.mi(a);
        }
        ct() {
            this.y3 = new ScatterContourSeriesView(this);
            return this.y3;
        }
        get y7() {
            return this.y6;
        }
        set y7(a) {
            let b = this.y7 != a;
            if (b) {
                let c = this.y7;
                this.y6 = a;
                this.raisePropertyChanged("ValueColumn", c, this.y7);
            }
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.kr(c);
            let e = d == null ? NaN : this.iz(d, "XMemberPath");
            let f = d == null ? NaN : this.iz(d, "YMemberPath");
            let g = d == null ? NaN : this.iz(d, "ValueMemberPath");
            let h = new DataLegendSeriesValueInfo();
            h.a = 13;
            h.l = e;
            h.q = "X";
            h.r = this.ya != null ? this.ya : "X";
            h.s = this.x6 != null ? this.x6 : "X:";
            h.t = this.x8 != null ? this.x8 : "";
            let i = new DataLegendSeriesValueInfo();
            i.a = 14;
            i.l = f;
            i.q = "Y";
            i.r = this.yi != null ? this.yi : "Y";
            i.s = this.ye != null ? this.ye : "Y:";
            i.t = this.yg != null ? this.yg : "";
            let j = new DataLegendSeriesValueInfo();
            j.a = 0;
            j.l = g;
            j.q = "Value";
            j.r = this.zf != null ? this.zf : "Value";
            j.s = this.zb != null ? this.zb : "V:";
            j.t = this.zd != null ? this.zd : "";
            let k = new DataLegendSeriesContext();
            k.e = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(h);
                $ret.add(i);
                $ret.add(j);
                return $ret;
            })());
            k.h = this.mh();
            return k;
        }
        rg(a, b, c, d) {
            super.rg(a, b, c, d);
            switch (b) {
                case ScatterContourSeries.$$p[2]:
                case ScatterContourSeries.$$p[3]:
                    this.ql();
                    break;
                case "FastItemsSource":
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.y7);
                        this.y7 = null;
                    }
                    let f = typeCast(IFastItemsSource_$type, d);
                    if (f != null) {
                        this.y7 = this.dl(this.zf);
                    }
                    this.ry(this.gh && c != null);
                    break;
                case ScatterContourSeries.$$p[4]:
                    if (this.dp != null) {
                        this.dp.deregisterColumn(this.y7);
                        this.y7 = this.dl(this.zf);
                    }
                    this.ry(false);
                    this.qr();
                    break;
                case "ValueResolver":
                    this.ry(false);
                    this.qr();
                    break;
                case ScatterContourSeries.$$p[1]:
                    let g = c;
                    let h = d;
                    if (g != null) {
                        g.unregisterSeries(this);
                    }
                    if (h != null) {
                        h.registerSeries(this);
                    }
                    this.zj();
                    this.ry(false);
                    this.qr();
                    break;
                case "ActualBrush":
                    this.zj();
                    this.ry(false);
                    this.qr();
                    break;
            }
        }
        pb(a, b) {
            super.pb(a, b);
            if (a) {
                b.cj(a);
            }
        }
        rz(a) {
            super.rz(a);
            this.zi(this.cw);
        }
        rx(a, b, c, d, e) {
            super.rx(a, b, c, d, e);
            let f = this.ba.a$j.item(d);
            f.bd(c);
            if (this.d7(f)) {
                return;
            }
            this.zi(f);
        }
        zi(a) {
            if (this.d7(a)) {
                return;
            }
            let b;
            let c;
            let d = a;
            let e = a.getViewInfo(c, b);
            c = e.p0;
            b = e.p1;
            let f = new ScalerParams(1, b, c, this.w8.df);
            f.c = this.getEffectiveViewport1(a);
            let g = new ScalerParams(1, b, c, this.w9.df);
            g.c = this.getEffectiveViewport1(a);
            let h = this.w8;
            let i = this.w9;
            let j = this.xi.count;
            let k;
            let xArr_ = this.xl.asArray();
            k = (xArr_.slice(0));
            let l;
            let yArr_ = this.xm.asArray();
            l = (yArr_.slice(0));
            let m = this.y7.asArray();
            let n = this.xi.asArray();
            let o = this.xj.asArray();
            let p = this.xk.asArray();
            let q = this.y2.j(this.y7);
            let r = new List$1(Number_$type, 1, q).toArray();
            h.j6(boxArray$1(k), 0, k.length, f);
            i.j6(boxArray$1(l), 0, l.length, g);
            let s = r.length;
            let t = new Array(s);
            for (let u = 0; u < s; ++u) {
                t[u] = new ContourBuilder();
            }
            let v = c.top;
            let w = c.left;
            let x = c.right;
            let y = c.bottom;
            let z;
            let aa;
            let ab;
            let ac;
            let ad = k.length;
            for (let ae = 0; ae < j; ae++) {
                let af = n[ae];
                let ag = o[ae];
                let ah = p[ae];
                if ((af >= ad) || (ag >= ad) || (ah >= ad) || (af < 0) || (ag < 0) || (ah < 0)) {
                    continue;
                }
                let ai = k[af];
                let aj = l[af];
                let ak = { $type: Point_$type, x: ai, y: aj };
                let al = k[ag];
                let am = l[ag];
                let an = { $type: Point_$type, x: al, y: am };
                let ao = k[ah];
                let ap = l[ah];
                let aq = { $type: Point_$type, x: ao, y: ap };
                z = an.y < aq.y ? an.y : aq.y;
                z = ak.y < z ? ak.y : z;
                aa = an.y > aq.y ? an.y : aq.y;
                aa = ak.y > aa ? ak.y : aa;
                ab = an.x < aq.x ? an.x : aq.x;
                ab = ak.x < ab ? ak.x : ab;
                ac = an.x > aq.x ? an.x : aq.x;
                ac = ak.x > ac ? ak.x : ac;
                if (z < y && aa > v && ab < x && ac > w) {
                    let ar = m[af];
                    let as = m[ag];
                    let at = m[ah];
                    if (isNaN_(ar) || isNaN_(as) || isNaN_(at)) {
                        continue;
                    }
                    for (let au = 0; au < s; au++) {
                        let av = r[au];
                        let aw = t[au];
                        switch ((ar < av ? 1 : 0) | (as < av ? 2 : 0) | (at < av ? 4 : 0)) {
                            case 0: break;
                            case 1:
                                aw.d(aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av), aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av));
                                break;
                            case 2:
                                aw.d(aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av), aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av));
                                break;
                            case 3:
                                aw.d(aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av), aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av));
                                break;
                            case 4:
                                aw.d(aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av), aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av));
                                break;
                            case 5:
                                aw.d(aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av), aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av));
                                break;
                            case 6:
                                aw.d(aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av), aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av));
                                break;
                            case 7: break;
                        }
                    }
                }
            }
            let ax = new Clipper(0, RectUtil.r(c, 2), false);
            let ay = new List$1(List$1.$.specialize(List$1.$.specialize(Point_$type)), 0);
            for (let az = 0; az < s; ++az) {
                let a0 = t[az];
                let a1 = new List$1(List$1.$.specialize(Point_$type), 0);
                let a2 = a0.c();
                for (let a3 = 0; a3 < a2.count; a3++) {
                    let a4 = a2._inner[a3];
                    let a5 = new List$1(Point_$type, 0);
                    ax.i = a5;
                    for (let a6 of fromEnum(a4)) {
                        ax.j({ $type: Point_$type, x: a0.g.item(a6), y: a0.h.item(a6) });
                    }
                    ax.i = null;
                    a1.add(a5);
                }
                ay.add(a1);
            }
            d.ci(ay, r);
        }
        sp() {
            super.sp();
            this.zj();
        }
        zj() {
            let a = this.vj;
            if (a == null) {
                a = this.vp;
            }
            if (a == null) {
                a = BrushUtil.j(255, 255, 255, 255);
            }
            let b = new ValueBrushScale();
            b.brushes = new BrushCollection();
            if (this.y5 == null || this.y5.brushes == null || this.y5.brushes.count == 0) {
                b.brushes.add(BrushUtil.o(a, -0.5));
                b.brushes.add(a);
            }
            else {
                for (let c of fromEnum(this.y5.brushes)) {
                    b.brushes.add(c);
                }
            }
            if (this.y5 != null) {
                if (!isNaN_(this.y5.minimumValue)) {
                    b.minimumValue = this.y5.minimumValue;
                }
                if (!isNaN_(this.y5.maximumValue)) {
                    b.maximumValue = this.y5.maximumValue;
                }
                b.logarithmBase = this.y5.logarithmBase;
                b.isLogarithmic = this.y5.isLogarithmic;
            }
            this.y4 = b;
        }
        get y2() {
            return this.y1;
        }
        set y2(a) {
            let b = a != this.y2;
            if (b) {
                if (this.y1 != null) {
                    let c = this.y1;
                    c.updated = delegateRemove(c.updated, runOn(this, this.zk));
                }
                let d = this.y1;
                this.y1 = a;
                if (this.y1 != null) {
                    let e = this.y1;
                    e.updated = delegateCombine(e.updated, runOn(this, this.zk));
                }
                this.raisePropertyChanged("ValueResolver", d, a);
                this.ry(false);
            }
        }
        zk(a, b) {
            this.ry(false);
        }
        hf(a, b, c) {
            return super.hf(a, b, c) && this.y2 != null && this.xl != null && this.xm != null && this.xi != null && this.xj != null && this.xk != null && this.xl.count > 0 && this.xm.count > 0 && this.xi.count > 0 && this.xj.count > 0 && this.xk.count > 0;
        }
        a2(a, b) {
            let c = this.y3.cn(a, b);
            if (c != null) {
                return c.dataContext;
            }
            return null;
        }
    }
    ScatterContourSeries.$t = markType(ScatterContourSeries, 'ScatterContourSeries', ScatterTriangulationSeries.$);
    ScatterContourSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterContourSeries, 'raisePropertyChanged', ['ActualFillScale:y4:zl', [ValueBrushScale.$, null], 'FillScale:y5:zm', [ValueBrushScale.$, null], 'ValueMemberAsLegendLabel:zb:zn', [2, null], 'ValueMemberAsLegendUnit:zd:zo', [2, null], 'ValueMemberPath:zf:zp', [2, null]]);
    return ScatterContourSeries;
})();
/**
 * @hidden
 */
export let ScatterContourSeriesView = /*@__PURE__*/ (() => {
    class ScatterContourSeriesView extends SeriesView {
        constructor(a) {
            super(a);
            this.cf = null;
            this.ce = null;
            this.ch = null;
            this.cg = new List$1(Brush.$, 0);
            this.cd = null;
            this.ch = new List$1(Path.$, 0);
            this.ce = a;
            this.cf = ((() => {
                let $ret = new Pool$1(Path.$);
                $ret.create = runOn(this, this.co);
                $ret.destroy = runOn(this, this.cm);
                $ret.activate = runOn(this, this.ck);
                $ret.disactivate = runOn(this, this.cl);
                return $ret;
            })());
        }
        co() {
            let a = new Path();
            a.dataContext = ((() => {
                let $ret = new DataContext();
                $ret.series = this.f;
                return $ret;
            })());
            this.ch.add(a);
            return a;
        }
        ck(a) {
            a._visibility = 0;
        }
        cl(a) {
            a._visibility = 1;
        }
        cm(a) {
            this.ch.remove(a);
        }
        ci(a, b) {
            let c = 0;
            this.cd = b;
            this.cg.clear();
            let d = this.ce.y4;
            for (let e = 0; e < b.length; e++) {
                let f = b[e];
                let g = a._inner[c];
                let h = new PathGeometry();
                for (let i = 0; i < g.count; i++) {
                    let j = g._inner[i];
                    if (j.count == 0) {
                        continue;
                    }
                    let k = PointCollectionUtil.f(j);
                    let l = ((() => {
                        let $ret = new PathFigure();
                        $ret.isClosed = false;
                        $ret.isFilled = false;
                        $ret.startPoint = k._inner[0];
                        return $ret;
                    })());
                    l._segments.add(((() => {
                        let $ret = new PolyLineSegment();
                        $ret.points = k;
                        return $ret;
                    })()));
                    h.c.add(l);
                }
                this.cf.item(c).an = h;
                if (this.cf.item(c).dataContext != null) {
                    this.cf.item(c).dataContext.item = f;
                }
                if (d != null) {
                    let m = d.getBrushByValue(f, this.ce.y7);
                    if (m == null) {
                        m = this.f.vj;
                    }
                    this.cg.add(m);
                }
                else {
                    this.cg.add(this.f.vj);
                }
                c++;
            }
            this.cf.count = c;
            this.a2();
        }
        bs(a, b) {
            super.bs(a, b);
            let c = a;
            c._stroke = this.cg._inner[b];
            c.ad = this.f.ig;
            if (c.y != null) {
                this.m.j(c, c.y);
            }
        }
        bt(a, b) {
            super.bt(a, b);
            let c = a;
            let d = this.b4(b);
            c._stroke = d;
            c.ad = this.f.ig + 3;
        }
        bj(a, b) {
            super.bj(a, b);
            for (let c = 0; c < this.ch.count; c++) {
                let d = this.ch._inner[c];
                if (d._visibility != 1) {
                    this.br(d, c, b);
                    a.t(d);
                }
            }
        }
        cj(a) {
            this.cf.count = 0;
            this.a2();
        }
        ax(a) {
            super.ax(a);
            let b = new List$1(Tuple$2.$.specialize(Number_$type, Path.$), 0);
            if (this.cd != null) {
                for (let c = 0; c < this.cf.count; c++) {
                    b.add(new Tuple$2(Number_$type, Path.$, this.cd[c], this.cf.item(c)));
                }
            }
            b.aa((d, e) => {
                if (d.c < e.c) {
                    return -1;
                }
                else if (d.c > e.c) {
                    return 1;
                }
                return 0;
            });
            for (let d = 0; d < b.count; d++) {
                let e = typeCast(Path.$, b._inner[d].d);
                if (e._visibility != 1) {
                    this.f.bc.exportPathData(a, e, "contour" + d, ["Main "]);
                }
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.f.ba.a$u(this.f);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.ce.title + "</span><br/>";
            if (!stringIsNullOrEmpty(this.ce.zf)) {
                a += "<span>Value: ${item}</span>";
            }
            a += "</div>";
            return a;
        }
        cn(a, b) {
            for (let c = 0; c < this.ch.count; c++) {
                let d = this.ch._inner[c];
                let e = typeCast(PathGeometry.$, d.an);
                if (e != null) {
                    for (let f = 0; f < e.c.count; f++) {
                        let g = e.c._inner[f];
                        let h = e.c._inner[f]._startPoint;
                        for (let i = 0; i < g._segments.count; i++) {
                            let j = typeCast(PolyLineSegment.$, g._segments._inner[i]);
                            if (j != null) {
                                let k = this.ce.ig / 2 + this.ce.iw(b);
                                if (j._points.count > 0 && GeometryUtil.e(a, h, j._points, k)) {
                                    return d;
                                }
                            }
                        }
                    }
                }
            }
            return null;
        }
    }
    ScatterContourSeriesView.$t = markType(ScatterContourSeriesView, 'ScatterContourSeriesView', SeriesView.$);
    return ScatterContourSeriesView;
})();
